/***************************************************************************
                          ksplashinstaller.cpp  -  description
                             -------------------
    begin                : Wed Apr 24 17:41:46 IST 2002
    copyright            : (C) 2002 by Balaji Srinivasan
    email                : vinylrecord@yahoo.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <qapplication.h>
#include <qpushbutton.h>
#include <qhbox.h>
#include <qpixmap.h>
#include <qlabel.h>
#include <qdir.h>
#include <qcombobox.h>
#include <qlistbox.h>
#include <qfont.h>
#include <qinputdialog.h>

#include <qfiledialog.h>
//#include <kfiledialog.h>

#include <kapp.h>

#include <stdlib.h>
#include <unistd.h>

#include "ksplashinstaller.h"


QLabel *lblTop, *lblActive, *lblBottom;
QLabel *lblCaption;

QComboBox *cboSplash;

const QString INSTALL_PATH = QDir::homeDirPath() + "/TestSplashInstaller/";
const QString KSPLASH_PATH = QDir::homeDirPath() + "/.kde/share/apps/ksplash/pics/";
const QString TMP_PATH = QDir::homeDirPath() + "/.kde/share/apps/ksplash/tmp/";

void KSplashInst::dirSelected(const QString &string)
{

	//QString cFile = string + "/splash_top.png";

	QString cPath = INSTALL_PATH + string;

	//string.append("/");

	//printf("\nDir Selected: %s", string.latin1());
	printf("\nPath: %s", cPath.latin1());

	lblCaption->setText(string);


	QPixmap picTop;
	picTop.load(cPath + "/splash_top.png");
	lblTop->setPixmap(picTop);

	QPixmap picActive;
	picActive.load(cPath + "/splash_active_bar.png");
	lblActive->setPixmap(picActive);


	QPixmap picBottom;
	picBottom.load(cPath + "/splash_bottom.png");
	lblBottom->setPixmap(picBottom);



}

void KSplashInst::about()
{
	printf("\nby vinylrecord.\n");
}


void KSplashInst::test1()
{
	system("ksplash --test");
}

void KSplashInst::test()
{

	QString *cCommand;
	//Take a backup of the current files

	cCommand = new QString("rm -rf " + TMP_PATH);
	printf("Command: %s\n", cCommand->latin1());
	system(cCommand->latin1());

	cCommand = new QString("cp -rf " + KSPLASH_PATH + " " + TMP_PATH);
	printf("Command: %s\n", cCommand->latin1());
	system(cCommand->latin1());

	apply();

	printf("Splash Start\n");
	system("ksplash --test");
	printf("Splash End\n");
	//Restore

	sleep(2);

	cCommand = new QString("rm -rf " + KSPLASH_PATH);
	printf("Command: %s\n", cCommand->latin1());
	system(cCommand->latin1());

	cCommand = new QString("cp -rf " + TMP_PATH + " " + KSPLASH_PATH);
	printf("Command: %s\n", cCommand->latin1());
	system(cCommand->latin1());


}

void KSplashInst::addFile()
{
	QString cFileName (QFileDialog::getOpenFileName(QString::null,"SplashScreen Files (*.gz *.zip *.tgz)",this, "Select the Splash to install"));




	if ( cFileName.isEmpty() )
        return;

	printf("File:%s", cFileName.latin1());

	QString cExt;
	int iExtLen = 3;
	cExt = cFileName.right(iExtLen);

	if (cExt == ".gz")
	{
		cExt = "tar.gz";
		iExtLen=6;
	}

	printf("FileType: %s", cExt.latin1());
	QString cSplashName = cFileName.left( cFileName.length() - iExtLen - 1);
	int iPos = cSplashName.findRev("/");
	printf("Splash Name1: %s\n", cSplashName.latin1());
	cSplashName = cSplashName.right(cSplashName.length() - iPos);

	printf("Splash Name: %s\n", cSplashName.latin1());



	//Prompt for Confirmation
	bool ok = FALSE;
  cSplashName = QInputDialog::getText( tr( "Splash Name" ), tr( "Please enter a name for this splash theme (no spaces). " ), cSplashName, &ok, this );
  if ( ok && !cSplashName.isEmpty() )
	{

	}

  else
	{
		return;
	}


//	cSplashName = "/" + cSplashName;

	QString cCommand1 = "mkdir " + INSTALL_PATH + cSplashName + "/";
	printf("\n%s\n", cCommand1.latin1());
	system(cCommand1.latin1());

	if (cExt == ".gz" || cExt == "tgz")
	{
		QString cCommand2 = "tar -xvzf " + cFileName + " -C " + INSTALL_PATH + cSplashName + "/ --overwrite";
		printf("\n%s\n", cCommand2.latin1());
		system(cCommand2.latin1());
	}

	if (cExt == "zip")
	{
		QString cCommand2 = "unzip " + cFileName + " -d " + INSTALL_PATH + cSplashName + "/";
		printf("\n%s\n", cCommand2.latin1());
		system(cCommand2.latin1());
	}


loadDir();
}

void KSplashInst::addDir()
{
}

void KSplashInst::createKSplashDir()
{
	QString *cCommand;

	cCommand = new QString("mkdir " + QDir::homeDirPath() + "/.kde/share/apps/ksplash/");
	printf("\nCommand1: %s\n", cCommand->latin1());
	system(cCommand->latin1());

	cCommand = new QString("mkdir " + KSPLASH_PATH);
	printf("Command2: %s\n", cCommand->latin1());
	system(cCommand->latin1());

	cCommand = new QString("mkdir " + TMP_PATH);
	printf("Command2: %s\n", cCommand->latin1());
	system(cCommand->latin1());

}


void KSplashInst::apply()
{
	QString *cCommand;
	//Now copy the files to the dir...
	cCommand = new QString("cp -f " + INSTALL_PATH + lblCaption->text() + "/* " + KSPLASH_PATH);
	printf("Commandapply: %s\n", cCommand->latin1());
	system(cCommand->latin1());
}


void KSplashInst::showSplash(const QString cDir)
{


}

void KSplashInst::loadDir()
{

	QString cPath = INSTALL_PATH;

	QDir *dir = new QDir(cPath);
	dir->setFilter(QDir::Dirs | QDir::Hidden);

	if (dir->exists() == FALSE)
	{
		QString cMakeDir = "mkdir " + cPath;
		system(cMakeDir.latin1());
		printf("\nCreating default path: %s", cMakeDir.latin1());
	}

	const QFileInfoList *fileList = dir->entryInfoList();
	QFileInfoListIterator fileListIt(*fileList);
	QFileInfo *fileInfo;

	cboSplash->clear();
	cboSplash->insertItem("-Choose a Splash-");


	while(fileInfo = fileListIt.current())
	{
		//Remove current and up directories
		if( (fileInfo->fileName()).compare("..")!=0 )
		{
			if( (fileInfo->fileName()).compare(".")!=0 )
			{
				cboSplash->insertItem(fileInfo->fileName());
			}
		}
		++fileListIt;
	}
}



KSplashInst::KSplashInst(QWidget *parent, const char *name):
QVBox(parent,name)
{

	this->setCaption("K Splash Installer");

	QHBox *mainBox = new QHBox(this);
	mainBox->setSpacing(10);
	mainBox->setMargin(10);

	QVBox *leftBox = new QVBox(mainBox);
//	leftBox->setMinimumWidth(10);

	QVBox *outerBox = new QVBox(mainBox);
	outerBox->setSpacing(10);
	outerBox->setMargin(10);

	QHBox *comboBox = new QHBox(outerBox);
	QLabel *lblInstalledSplash = new QLabel("Installed Splash Screens:", comboBox);
	lblInstalledSplash->setMaximumWidth(150);

	cboSplash = new QComboBox(comboBox);

	QVBox *box = new QVBox(outerBox);
	box->setFixedSize(430,370);
	//box->setSpacing(10);
	box->setMargin(10);
	box->setFrameStyle(WinPanel);
	box->setFrameShadow(Raised);


	QVBox *middleBox = new QVBox(mainBox);

	QVBox *sideBox = new QVBox(mainBox);
	sideBox->setFixedSize(100,400);

//	QVBox *rightBox = new QVBox(mainBox);
//	rightBox->setMinimumWidth(10);



	createKSplashDir();

	loadDir();

	lblCaption = new QLabel(box);

	QFont myFont(QApplication::font());
	myFont.setBold(TRUE);

	lblCaption->setFont(myFont);
	lblCaption->setAlignment(AlignHCenter);

	lblTop = new QLabel(box);


	lblActive = new QLabel(box);
	lblBottom = new QLabel(box);





	box->show();


	QPushButton *addFile = new QPushButton("&Install...", sideBox);
//	QPushButton *addDir = new QPushButton("&Add Splash Directory...", sideBox);
	QPushButton *apply = new QPushButton("&Apply", sideBox);
	QPushButton *test = new QPushButton("&Test", sideBox);
//	QPushButton *test1 = new QPushButton("&Test1", sideBox);

	QPushButton *about = new QPushButton("A&bout", sideBox);
	QPushButton *close = new QPushButton("&Close", sideBox);

//	close->setGeometry(62,50,75,30);

	QObject::connect(close, SIGNAL(clicked()), qApp, SLOT(quit()));
	QObject::connect(test, SIGNAL(clicked()), SLOT(test()));

//	QObject::connect(test1, SIGNAL(clicked()), SLOT(test1()));

	QObject::connect(apply, SIGNAL(clicked()), SLOT(apply()));
	QObject::connect(addFile, SIGNAL(clicked()), SLOT(addFile()));

	QObject::connect(about, SIGNAL(clicked()), SLOT(about()));

//	QObject::connect(addDir, SIGNAL(clicked()), SLOT(addDir()));

	QObject::connect(cboSplash, SIGNAL(highlighted(const QString &)), SLOT(dirSelected(const QString &)) );
	QObject::connect(cboSplash, SIGNAL(activated(const QString &)), SLOT(dirSelected(const QString &)) );

}
